#ifndef PROJECT2_INC_READ_HPP
#define PROJECT2_INC_READ_HPP

#include <string>
#include <vector>

/* stovi:
*     convert string s to vector<int> no matter the cost

   @param &s   const reference to a string

   @returns vector<int>: signed integer representations
            of the groups of contiguous digits in the string
*/
std::vector<int> stovi (const std::string &s);

/* print_errpr_message:
*     Print the error message associated with the given error number

   @param error      int representing the error states of graph::read()
   @param filename   string containing the name of a file

   @returns void

*/
void print_error_message (int error, std::string filename);

#endif // PROJECT2_INC_READ_HPP